/*******************************************************************************
**  DAVE App Name : ADC001       App Version: 1.0.20               
**  This file is generated by DAVE, User modification to this file will be    **
**  overwritten at the next code generation.                                  **
*******************************************************************************/

/*CODE_BLOCK_BEGIN[ADC001Conf.h]*/

/******************************************************************************
 *
 * Copyright (C) 2013 Infineon Technologies AG. All rights reserved.
 *
 * Infineon Technologies AG (Infineon) is supplying this software for use with
 * Infineon's microcontrollers.
 * This file can be freely distributed within development tools that are
 * supporting such microcontrollers.
 *
 * THIS SOFTWARE IS PROVIDED "AS IS".  NO WARRANTIES, WHETHER EXPRESS, IMPLIED
 * OR STATUTORY, INCLUDING, BUT NOT LIMITED TO, IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE APPLY TO THIS SOFTWARE.
 * INFINEON SHALL NOT, IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL,
 * OR CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.
 *
********************************************************************************
**                                                                            **
**                                                                            **
** PLATFORM : Infineon XMC4000/XMC1000 Series                                 **
**                                                                            **
** COMPILER : Compiler Independent                                            **
**                                                                            **
** AUTHOR   : DAVE App Developer                                              **
**                                                                            **
** MAY BE CHANGED BY USER [yes/Yes]: Yes                                      **
**                                                                            **
** MODIFICATION DATE : Sep 27, 2013                                           **
**                                                                            **
*******************************************************************************/

/*******************************************************************************
**                       Author(s) Identity                                   **
********************************************************************************
**                                                                            **
** Initials     Name                                                          **
** ---------------------------------------------------------------------------**
** CM           DAVE App Developer                                            **
*******************************************************************************/

/**
 * @file  ADC001_Conf.h
 *
 * @brief This file contains App parameter data as per GUI configurations
 *
 * Change History:
 *
 * Date       version       Details
 * 16-Dec-2012   1.0.4    Initial code added for XMC1000
 * 06-Mar-2013   1.0.6    App version changed for XMC1000 and XMC4400/XMC4200
 * 24-Apr-2013   1.0.8    Ported to XMC4500 step AB and
 *                        Source Result selection Feature added
 * 11-Jun-2013   1.0.10   1. In channel selection page Group C and Group D check 
 *                        boxes made invisible for XMC1200/1300/4200 devices.
 *                        2. In the Header comment section device name changed
 *                           to XMC1000.
 *                        3. Tooltip for the Group channel selection is modified.
 *                        4. New api ADC001_GetFastResult() implemented.
 *                        5. Source Result register selection feature disabled
 *                           due to header file update not available.     
 * 27-Jun-2013   1.0.12   Source Result register selection feature removed to
 *                        simplify the app.
 * 27-Sep-2013   1.0.16   Typos in API Documentation & .h comments is corrected. 
 */
#ifndef ADC001CONF_H_
#define ADC001CONF_H_

#ifdef __cplusplus
extern "C" {
#endif

#include <DAVE3.h>


extern const ADC001_HandleType ADC001_Handle0;
extern const ADC001_ChannelHandleType* ADC001_ChannelHandlePtr[];

extern const ADC001_ChannelHandleType ADC001_ChannelAAHandle;

#ifdef __cplusplus
}
#endif
  
#endif /* ADC001CONF_H_ */

/**
 * @}
 */
 
/*CODE_BLOCK_END*/

