/*******************************************************************************
**  DAVE App Name : ADCGLOB001       App Version: 1.0.26               
**  This file is generated by DAVE, User modification to this file will be    **
**  overwritten at the next code generation.                                  **
*******************************************************************************/

/*CODE_BLOCK_BEGIN[ADCGLOB001CONF.h]*/

/******************************************************************************
 *
 * Copyright (C) 2013 Infineon Technologies AG. All rights reserved.
 *
 * Infineon Technologies AG (Infineon) is supplying this software for use with
 * Infineon's microcontrollers.
 * This file can be freely distributed within development tools that are
 * supporting such microcontrollers.
 *
 * THIS SOFTWARE IS PROVIDED "AS IS".  NO WARRANTIES, WHETHER EXPRESS, IMPLIED
 * OR STATUTORY, INCLUDING, BUT NOT LIMITED TO, IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE APPLY TO THIS SOFTWARE.
 * INFINEON SHALL NOT, IN ANY CIRCUMSTANCES, BE LIABLE FOR SPECIAL, INCIDENTAL,
 * OR CONSEQUENTIAL DAMAGES, FOR ANY REASON WHATSOEVER.
 *
********************************************************************************
**                                                                            **
**                                                                            **
** PLATFORM : Infineon XMC4000/XMC1000 Series                                 **
**                                                                            **
** COMPILER : Compiler Independent                                            **
**                                                                            **
** AUTHOR   : App Developer                                                   **
**                                                                            **
** MAY BE CHANGED BY USER [yes/no]: Yes                                       **
**                                                                            **
** MODIFICATION DATE : Nov 14, 2013                                           **
**                                                                            **
*******************************************************************************/

/*******************************************************************************
**                       Author(s) Identity                                   **
********************************************************************************
**                                                                            **
** Initials     Name                                                          **
** ---------------------------------------------------------------------------**
**PrashanA           App Developer                                            **
*******************************************************************************/

/**
 * @file  ADCGLOB001CONF.h
 *
 * @brief This file contains App parameter data as per GUI configurations
 *
 * Change History:
 * Date       version       Details
 * 12-Dec-2012   1.0.5    Initial code added for XMC1000
 * 18-Jan-2013   1.0.6    Merging with XMC1000 done
 * 24-Apr-2013   1.0.12   Ported to XMC4500 step AB and
 *                        Source Result selection Feature added
 * 10-Jun-2013   1.0.14   1. Supported for XMC1100 device,  
 *                        2. Comment in header section - the Device series name is
 *                           made as XMC1000
 * 27-Jun-2013   1.0.16   Global limits made unavailable for adc004 app
 * 29-Aug-2013   1.0.18   XMC1200/XMC1300 New Sofware IDS added.
 *                        Unused code removed 
 * 31-Oct-2013   1.0.20   1. The macro name ADCGLOB001_DBG002_FUNCTION_ENTRY is 
 *                        corrected as ADCGLOB001_FUNCTION_ENTRY 
 *                        2. Analog Clock divider value minimum 1 was generated
 *                        and now it is made as 0 for XMC1000 devices.
 * 14-Nov-2013   1.0.22   CLK001_Init() for XMC4000 devices CLK002_Init() for 
 *                        XMC1000 devices is removed in ADCGLOB001_Init() 
 *                        function, since this CLK00x_Init() function is called
 *                        at the beginning  of the DAVE_Init() function. 
 */
#ifndef ADCGLOB001CONF_H_
#define ADCGLOB001CONF_H_

#ifdef __cplusplus
extern "C" {
#endif

#include <DAVE3.h>




extern const ADCGLOB001_HandleType ADCGLOB001_Handle0;

#ifdef __cplusplus
}
#endif
  
#endif /* ADCGLOB001CONF_H_ */

/**
 * @}
 */
 
/*CODE_BLOCK_END*/

